(provide "puzzle")

#| 15 or n puzzle for xyzzy

Copyright (C) 2009 knenet
 All rights reserved.
 <kneneglect_std@yahoo.co.jp>

TvF

TCYςɂł邾̂ʂ15pYB
Ԃ̓`FbN̂ŉȂƂ͂Ȃ͂B

g:

̈ʒuɒu
(require "puzzle")
]BM-x puzzle sB
sƃTCY𕷂̂ X*Y œ͂B
15pYȂ4*4B

VѕF
J[\L[Ƃŋ()ړB
󔒂ɂĐ񂵂Ԃɂ邱ƂڕWB
5ƖڕW̕\؂ւB

j
 12
345
678

IReturnŏB

ӁF
1*10̂悤ȃpY͉ȂB
Ԃ𑪂莩ŉ肷@\͂ȂB

F
001 2009-06-02 23:18 łB
002 2009-06-03 07:31 ]|𐔂Ĕ肷悤ɂB
003 2009-06-03 07:39 J[\̈ʒuBڕW̕\؂ւB
|#

(defpackage "puzzle"
  (:use "lisp" "editor"))

(in-package "puzzle")

(export '(*puzzle-mode-hook* *puzzle-mode-map* puzzle puzzle-init))
(use-package "puzzle" "user")

(defvar *puzzle-buffer* "*puzzle*")
(defvar *state* nil)
(defvar *show* nil)
(defvar *path* nil)
(defvar *way* nil)
(defvar *goal* nil)
(defvar *show-goal* nil)

(defvar *puzzle-mode-hook* nil)

(defvar *puzzle-mode-map* nil)
(unless *puzzle-mode-map*
  (setq *puzzle-mode-map* (make-sparse-keymap))
  (define-key *puzzle-mode-map* #\RET 'puzzle-init)
  (define-key *puzzle-mode-map* #\C-p 'puzzle-go-north)
  (define-key *puzzle-mode-map* #\C-n 'puzzle-go-south)
  (define-key *puzzle-mode-map* #\C-f 'puzzle-go-east)
  (define-key *puzzle-mode-map* #\C-b 'puzzle-go-west)
  (define-key *puzzle-mode-map* #\Up 'puzzle-go-north)
  (define-key *puzzle-mode-map* #\Down 'puzzle-go-south)
  (define-key *puzzle-mode-map* #\Right 'puzzle-go-east)
  (define-key *puzzle-mode-map* #\Left 'puzzle-go-west)
  (define-key *puzzle-mode-map* #\8 'puzzle-go-north)
  (define-key *puzzle-mode-map* #\2 'puzzle-go-south)
  (define-key *puzzle-mode-map* #\6 'puzzle-go-east)
  (define-key *puzzle-mode-map* #\4 'puzzle-go-west)
  (define-key *puzzle-mode-map* #\5 'puzzle-toggle-show-goal))

(defun puzzle ()
  (interactive)
  (set-buffer (switch-to-buffer *puzzle-buffer*))
  (setup-temp-buffer *puzzle-buffer*)
  (set-buffer-fold-width nil)
  (puzzle-mode)
  (unless *state* (call-interactively 'puzzle-init))
  (puzzle-show))

(defun puzzle-show ()
  (save-excursion
	(let ((buff (switch-to-buffer *puzzle-buffer*)))
	  (set-buffer buff)
	  (erase-buffer buff)
	  (let ((sp (make-buffer-stream buff 0)))
		(format sp *show* (mapcar 'car (stable-sort (copy-tree *state*) '< :key 'cdr)))
		(goto-char (point-min))
		(replace-buffer "  0" " " :once 1)
		(if *show-goal*
			(format sp *show* (mapcar 'car (copy-tree *goal*))))))))

(defun puzzle-toggle-show-goal ()
  (interactive)
  (setq *show-goal* (not *show-goal*))
  (puzzle-show))

(defun puzzle-go-north ()
  (interactive)
  (puzzle-go-way 'north)
  (puzzle-show)
  (puzzle-goal-check))

(defun puzzle-go-east ()
  (interactive)
  (puzzle-go-way 'east)
  (puzzle-show)
  (puzzle-goal-check))

(defun puzzle-go-south ()
  (interactive)
  (puzzle-go-way 'south)
  (puzzle-show)
  (puzzle-goal-check))

(defun puzzle-go-west ()
  (interactive)
  (puzzle-go-way 'west)
  (puzzle-show)
  (puzzle-goal-check))

(defun puzzle-go-way (way)
  (move-state *state* (cdr (assoc way *way*))))

(defun swap-piece (state piece move-to)
  (rotatef (cdr piece) (cdr (rassoc move-to state)))
  state)

(defun move-piece (state piece path)
  (let ((mover (member (cdr piece) path :key 'car)))
    (if mover (swap-piece state piece (cdar mover)))
    mover))

(defun move-state (state path)
  (let ((mover (member (cdar state) path :key 'car)))
    (if mover (next-state state (cdar mover)) (ding))
    mover))

(defun next-state (state move-to)
  (rotatef (cdar state) (cdr (rassoc move-to state)))
  state)

(defun make-grid-num (x y)
  (let (table (num -1))
	(dotimes (yi y (reverse table))
	  (let (column)
		(dotimes (xi x column)
		  (push (incf num) column))
		(push (reverse column) table)))))

(defun make-grid-path (grid)
  (do ((lm grid
		   (mapcar 'cdr lm))
	   (res))
	  ((null (apply 'append lm)) (nreverse res))
	(do ((li lm (cdr li)))
		((null li))
	  (macrolet ((! (x y) `(push (cons (,x li) (,y li)) res)))
		(when (cadar li)
		  (! caar cadar)
		  (! cadar caar))
		(when (cdr li)
		  (! caar caadr)
		  (! caadr caar))))))

(defun make-grid-way (grid)
  (do ((lm grid (mapcar 'cdr lm))
	   (res (cons t (mapcar 'list (list 'north 'south 'east 'west)))))
	  ((null (apply 'append lm))
	   (mapcar (lambda (x) (cons (car x) (nreverse (cdr x)))) (cdr res)))
	(do ((li lm (cdr li)))
		((null li))
	  (macrolet ((! (w x y)
				   `(treat (way ,w res)
					  (pushd (cons (,x li) (,y li)) way))))
		(when (cadar li)
		  (! 'east caar cadar)
		  (! 'west cadar caar))
		(when (cdr li)
		  (! 'south caar caadr)
		  (! 'north caadr caar))))))

(defmacro pushd (item place)
  `(rplacd ,place (cons ,item (cdr ,place))))

(defmacro treat ((it item place) &rest args)
  `(let ((,it (find ,item (cdr ,place) :key 'car)))
     (when ,it ,@args)))

(defun shuffle (lst)
  (let ((l (copy-seq lst))
        (len (1+ (length lst)))
        res)
    (while (plusp (decf len))
      (push (nthpop (random len) l) res))
    res))

(defun nthpop (x lst)
  (let* ((l (nthcdr x lst))
         (r (car l)))
    (rplaca l (cadr l))
    (rplacd l (cddr l))
    r))

(defun rollover (state)
  (apply '+ (maplist (lambda (x &aux (c 0))
					 (dolist (a (cdr x) c) (if (> (car x) a) (incf c))))
				   (mapcar 'car (stable-sort (copy-tree *state*) '< :key 'cdr)))))

(defun puzzle-goal-check ()
  (when (equal *goal* *state*)
	(refresh-screen)
	(long-operation (sit-for 1))
	(msgbox "Conguratuation!")
	(setq *goal* nil)))

(defun puzzle-init (x y)
  (interactive "npuzzle size x: \nnpuzzle size y: ")
  (long-operation
   (let ((num -1)
		 (proto (make-grid-num x y))
		 l1 l2 )
	 (dotimes (a (* x y))
	   (push (incf num) l1)
	   (push num l2))
	 (setq *goal* (pairlis l1 l2)
		   *state* (pairlis l1 (shuffle l2))
		   *path* (make-grid-path proto)
		   *way* (make-grid-way proto)
		   *show*
		   (let* ((sub1 (concat "~3" (if (> (* x y) 99) "X" "D") " "))
				  (sub2 (apply 'concat (make-list x :initial-element sub1)))
				  (sub3 (concat "" sub2 "~%"))
				  (sub4 (concat (format nil "~{~*~}" (cdar proto)) "~%" sub3))
				  (sub5 (apply 'concat (make-list (1- y) :initial-element sub4))))
			 (concat "~{"
					 (format nil "~{~*~}" (cdar proto)) "~%"
					 sub3 sub5
					 (format nil "~{~*~}" (cdar proto)) "~}~%~%")))
	 (if (oddp (rollover *state*))
		 (move-piece *state* (cadr *state*)
					 (remove (car *state*) *path* :test 'equal)))
	 (if (eq buffer-mode 'puzzle-mode) (puzzle-show) *state*))))

(defun puzzle-mode ()
  (interactive)
  (kill-all-local-variables)
  (setq buffer-mode 'puzzle-mode)
  (setq mode-name "Puzzle")
  (use-keymap *puzzle-mode-map*)
  (run-hooks '*puzzle-mode-hook*))
